# Installation

The instructions below will help you to properly installand run the generated package to the lavalite project.

## Location

Extract the package contents to the folder 

`/packages/customneonslight/customneonslight/`

## Composer

Add the below entries in the `composer.json`.


```json

...
     "repositories": {
        ...

        {
            "type": "path",
            "url": "packages/customneonslight/customneonslight"
        }

        ...
    },
...

```
Then run `composer require customneonslight/customneonslight`


## Migration and seeds

```
    php artisan migrate
    php artisan db:seed --class=Customneonslight\\Customneonslight\\Seeders\\CustomneonslightTableSeeder
```

## Publishing

* Configuration
```
    php artisan vendor:publish --provider="Customneonslight\Customneonslight\Providers\CustomneonslightServiceProvider" --tag="config"
```
* Language
```
    php artisan vendor:publish --provider="Customneonslight\Customneonslight\Providers\CustomneonslightServiceProvider" --tag="lang"
```
* Views
```
    php artisan vendor:publish --provider="Customneonslight\Customneonslight\Providers\CustomneonslightServiceProvider" --tag="view"
```

## URLs and APIs

### Web Urls

* Admin
```
    http://path-to-route-folder/admin/customneonslight/{modulename}
```

* User
```
    http://path-to-route-folder/user/customneonslight/{modulename}
```

* Public
```
    http://path-to-route-folder/customneonslights
```


### API endpoints

These endpoints can be used with or without `/api/`
And also the user can be varied depend on the type of users, eg user, client, admin etc.

#### Resource

* List
```
    http://path-to-route-folder/api/user/customneonslight/{modulename}
    METHOD: GET
```

* Create
```
    http://path-to-route-folder/api/user/customneonslight/{modulename}
    METHOD: POST
```

* Edit
```
    http://path-to-route-folder/api/user/customneonslight/{modulename}/{id}
    METHOD: PUT
```

* Delete
```
    http://path-to-route-folder/api/user/customneonslight/{modulename}/{id}
    METHOD: DELETE
```

#### Public

* List
```
    http://path-to-route-folder/api/customneonslight/{modulename}
    METHOD: GET
```

* Single Item
```
    http://path-to-route-folder/api/customneonslight/{modulename}/{slug}
    METHOD: GET
```

#### Others

* Report
```
    http://path-to-route-folder/api/user/customneonslight/{modulename}/report/{report}
    METHOD: GET
```

* Export/Import
```
    http://path-to-route-folder/api/user/customneonslight/{modulename}/exim/{exim}
    METHOD: POST
```

* Action
```
    http://path-to-route-folder/api/user/customneonslight/{modulename}/action/{id}/{action}
    METHOD: PATCH
```

* Actions
```
    http://path-to-route-folder/api/user/customneonslight/{modulename}/actions/{action}
    METHOD: PATCH
```

* Workflow
```
    http://path-to-route-folder/api/user/customneonslight/{modulename}/workflow/{id}/{transition}
    METHOD: PATCH
```
